VERSION 5.00
Begin VB.Form AstrLine 
   Appearance      =   0  'Flat
   AutoRedraw      =   -1  'True
   BackColor       =   &H00FFFFFF&
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Synastry Aspects"
   ClientHeight    =   6225
   ClientLeft      =   1170
   ClientTop       =   990
   ClientWidth     =   8160
   ControlBox      =   0   'False
   BeginProperty Font 
      Name            =   "Times New Roman"
      Size            =   9
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H00000000&
   Icon            =   "Astrline.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   311.25
   ScaleMode       =   0  'User
   ScaleWidth      =   408
   ShowInTaskbar   =   0   'False
End
Attribute VB_Name = "AstrLine"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim optopt%
Private Sub Form_KeyPress(KeyAscii As Integer)
    If KeyAscii = 27 Then
        AstroSrc.SetFocus
        KeyAscii = 0
    End If
End Sub

Private Sub Form_Load()
    AstrLine.ScaleMode = 1

    NoDo% = 1

    AstrLine.Cls
    AstrLine.Left = 0
    AstrLine.BackColor = QBColor(XOPTION!(159))

    AstrLine.FontName = "Astro123"
    AstrLine.FontSize = XOPTION!(153)
    AstrLine.Width = Screen.Width * 0.85
    AstrLine.Height = 4000
    AstrLine.Top = OutputD1.Top
    AstrLine.Left = AstroSrc.Left

    NoDo% = 0: optopt% = 0
End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    optopt% = optopt% + 1
    If optopt% = 3 Then optopt% = 0
    Form_Paint
End Sub

Private Sub Form_Paint()
    Dim cnt%, clr%, I As String, X3, t$, X%, Y%, xPos1(), xPos2(), LastPos, Offset%

    If NoDo% = 1 Then Exit Sub

    AstrLine.Cls
    AstrLine.BackColor = QBColor(XOPTION!(159))
    AstrLine.ScaleLeft = 0
    AstrLine.FontSize = XOPTION!(153)

    ReDim xPos1(NumberOfPlanets%), xPos2(NumberOfPlanets%)

'draw graph for 1st person
    SLX = AstrLine.TextWidth(Chr$(48))
    ELX = AstrLine.Width - (2 * AstrLine.TextWidth(Chr$(48)))
    SLY = 600

'draw full-length horizontal line
    Line (SLX, SLY)-(ELX, SLY), QBColor(XOPTION!(160))

'draw short vertical grid marks every 5 degrees
    For X3 = SLX To ELX Step (ELX - SLX) / 72
        Line (X3, SLY + 40)-(X3, SLY - 40), QBColor(XOPTION!(162))
    Next X3

'draw short vertical grid marks every 10 degrees
    For X3 = SLX To ELX Step (ELX - SLX) / 36
        Line (X3, SLY + 60)-(X3, SLY - 60), QBColor(XOPTION!(161))
    Next X3

    cnt% = 0
    AstrLine.FontSize = XOPTION!(164)
    AstrLine.ForeColor = QBColor(XOPTION!(165))

'draw signs on horizontal line along with higher vertical bar to show beginning on sign
    For X3 = SLX To ELX Step (ELX - SLX) / 12
        CurrentX = X3 - AstrLine.TextWidth(Chr$(194)) / 2
        CurrentY = SLY - 250 - AstrLine.TextHeight(Chr$(194)) / 3
        cnt% = cnt% + 1
        AstrLine.Print Chr$(191 + cnt%)
        Line (X3, SLY + 120)-(X3, SLY - 120), QBColor(XOPTION!(160))
    Next X3

'sort planets finding the lowest longitudes first
    For X% = 1 To NumberOfPlanets%
        SORT(X%) = Natal(X%): SORTPOS(X%) = X%
    Next X%

    For X% = 1 To NumberOfPlanets% - 1
        For Y% = X% + 1 To NumberOfPlanets%
            If SORT(Y%) < SORT(X%) Then
                temp = SORT(X%): temp1 = SORTPOS(X%)
                SORT(X%) = SORT(Y%): SORTPOS(X%) = SORTPOS(Y%)
                SORT(Y%) = temp: SORTPOS(Y%) = temp1
            End If
        Next Y%
    Next X%

    LastPos = -1000
    For X% = 1 To NumberOfPlanets%
        If SORTPOS(X%) < 11 Or SORTPOS(X%) = 14 Or SORTPOS(X%) = 16 Then
            CurrentX = (ELX - SLX) * SORT(X%) / 360
            If CurrentX > ELX - (NumberOfPlanets% + 1 - X%) * AstrLine.TextWidth(Chr$(230)) - (AstrLine.TextWidth(Chr$(230)) / 1.4) Then
                CurrentX = ELX - (NumberOfPlanets% - X%) * AstrLine.TextWidth(Chr$(230)) - (AstrLine.TextWidth(Chr$(230)) / 1.4)
            End If
            If CurrentX < LastPos + AstrLine.TextWidth(Chr$(SORTPOS(X%) + 223)) Then
                CurrentX = LastPos + AstrLine.TextWidth(Chr$(SORTPOS(X%) + 223))
            End If

            LastPos = CurrentX
            xPos1(SORTPOS(X%)) = CurrentX + AstrLine.TextWidth(Chr$(SORTPOS(X%) + 223)) / 2

            'CurrentY = SLY + 120 + (xP(x%) - 1) * AstrLine.TextHeight(Chr$(214))
            CurrentY = SLY + 120
            If Mid$(NatalH$, SORTPOS(X%), 1) = "R" Then
                AstrLine.FontSize = XOPTION!(154)
                AstrLine.ForeColor = QBColor(XOPTION!(158))
            Else
                AstrLine.FontSize = XOPTION!(153)
                AstrLine.ForeColor = QBColor(XOPTION!(157))
            End If
            AstrLine.Print Chr$(SORTPOS(X%) + 223)
        End If
    Next X%

    AstrLine.FontSize = XOPTION!(152)
    AstrLine.ForeColor = QBColor(XOPTION!(156))

'print text data (name)
    AstrLine.FontSize = XOPTION!(151)
    AstrLine.ForeColor = QBColor(XOPTION!(155))
    AstrLine.CurrentX = AstrLine.ScaleLeft + 10
    AstrLine.CurrentY = AstrLine.ScaleTop
    t$ = ZN$
    AstrLine.Print t$

'draw graph for 2nd person
    Offset% = 2400
    SLX = AstrLine.TextWidth(Chr$(48))
    ELX = AstrLine.Width - (2 * AstrLine.TextWidth(Chr$(48)))
    SLY = 600 + Offset%

'draw full-length horizontal line
    Line (SLX, SLY)-(ELX, SLY), QBColor(XOPTION!(160))

'draw short vertical grid marks every 5 degrees
    For X3 = SLX To ELX Step (ELX - SLX) / 72
        Line (X3, SLY + 40)-(X3, SLY - 40), QBColor(XOPTION!(162))
    Next X3

'draw short vertical grid marks every 10 degrees
    For X3 = SLX To ELX Step (ELX - SLX) / 36
        Line (X3, SLY + 60)-(X3, SLY - 60), QBColor(XOPTION!(161))
    Next X3

    cnt% = 0
    AstrLine.FontSize = XOPTION!(164)
    AstrLine.ForeColor = QBColor(XOPTION!(165))

'draw signs on horizontal line along with higher vertical bar to show beginning on sign
    For X3 = SLX To ELX Step (ELX - SLX) / 12
        CurrentX = X3 - AstrLine.TextWidth(Chr$(194)) / 2
        CurrentY = SLY + 250 - AstrLine.TextHeight(Chr$(194)) / 3
        cnt% = cnt% + 1
        AstrLine.Print Chr$(191 + cnt%)
        Line (X3, SLY + 120)-(X3, SLY - 120), QBColor(XOPTION!(160))
    Next X3

'sort planets finding the lowest longitudes first
    For X% = 1 To NumberOfPlanets%
        SORT(X%) = Transit(X%): SORTPOS(X%) = X%
    Next X%

    For X% = 1 To NumberOfPlanets% - 1
        For Y% = X% + 1 To NumberOfPlanets%
            If SORT(Y%) < SORT(X%) Then
                temp = SORT(X%): temp1 = SORTPOS(X%)
                SORT(X%) = SORT(Y%): SORTPOS(X%) = SORTPOS(Y%)
                SORT(Y%) = temp: SORTPOS(Y%) = temp1
            End If
        Next Y%
    Next X%

    LastPos = -1000
    For X% = 1 To NumberOfPlanets%
        If SORTPOS(X%) < 11 Or SORTPOS(X%) = 14 Or SORTPOS(X%) = 16 Then
            CurrentX = (ELX - SLX) * SORT(X%) / 360
            If CurrentX > ELX - (NumberOfPlanets% + 1 - X%) * AstrLine.TextWidth(Chr$(230)) - (AstrLine.TextWidth(Chr$(230)) / 1.4) Then
                CurrentX = ELX - (NumberOfPlanets% - X%) * AstrLine.TextWidth(Chr$(230)) - (AstrLine.TextWidth(Chr$(230)) / 1.4)
            End If
            If CurrentX < LastPos + AstrLine.TextWidth(Chr$(SORTPOS(X%) + 223)) Then
                CurrentX = LastPos + AstrLine.TextWidth(Chr$(SORTPOS(X%) + 223))
            End If

            LastPos = CurrentX
            xPos2(SORTPOS(X%)) = CurrentX + AstrLine.TextWidth(Chr$(SORTPOS(X%) + 223)) / 2

            'CurrentY = SLY + 120 + (xP(x%) - 1) * AstrLine.TextHeight(Chr$(214))
            CurrentY = SLY - 350
            If Mid$(TransitH$, SORTPOS(X%), 1) = "R" Then
                AstrLine.FontSize = XOPTION!(154)
                AstrLine.ForeColor = QBColor(XOPTION!(158))
            Else
                AstrLine.FontSize = XOPTION!(153)
                AstrLine.ForeColor = QBColor(XOPTION!(157))
            End If
            AstrLine.Print Chr$(SORTPOS(X%) + 223)
        End If
    Next X%

    AstrLine.FontSize = XOPTION!(152)
    AstrLine.ForeColor = QBColor(XOPTION!(156))

'print text data (name)
    AstrLine.FontSize = XOPTION!(151)
    AstrLine.ForeColor = QBColor(XOPTION!(155))
    AstrLine.CurrentX = AstrLine.ScaleLeft + 10
    AstrLine.CurrentY = AstrLine.ScaleTop + AstrLine.Height - 550
    t$ = InputD1!chk2ndPerson.Caption
    AstrLine.Print t$

'draw aspect lines
'calculate aspects and put aspects in grid
    Close #2: c = 0
    Open DefaultDirectory$ & "\SYNASTRY.ORB" For Input As #2
    Do While Not EOF(2)
       Line Input #2, I
       If I = "" Then Exit Do
       c = c + 1: CWAspects!(c) = Val(Left$(I, 7))
    Loop
    Close #2

    For Y = 1 To NumberOfPlanets%
        If Y = 11 Or Y = 12 Or Y = 13 Or Y = 15 Then GoTo fp1a
        For X = 1 To NumberOfPlanets%
            If X = 11 Or X = 12 Or X = 13 Or X = 15 Then GoTo fp1b
            If (Y = 7 Or Y = 8 Or Y = 9) And (X = 7 Or X = 8 Or X = 9) Then GoTo fp1b
            Q = 1
            DA = Abs(Natal(Y) - Transit(X))
            If DA > 180 Then DA = 360 - DA
            If DA <= (60 + CWAspects!(2)) And DA >= (60 - CWAspects!(2)) Then Q = 3
            If DA <= (90 + CWAspects!(3)) And DA >= (90 - CWAspects!(3)) Then Q = 4
            If DA <= (120 + CWAspects!(4)) And DA >= (120 - CWAspects!(4)) Then Q = 5
            If DA >= (180 - CWAspects!(5)) Then Q = 6
            'If DA <= (45 + CWAspects!(8)) And DA >= (45 - CWAspects!(8)) Then Q = 9
            'If DA <= (135 + CWAspects!(9)) And DA >= (135 - CWAspects!(9)) Then Q = 10
            If DA <= CWAspects!(1) Then Q = 2
            If Q > 1 Then
                If optopt% = 0 Then
                    AstrLine.Caption = "Synastry - squares (red) and oppositions (blue)"
                    If Q = 4 Then
                        clr% = 12
                        Line (xPos1(Y), 900)-(xPos2(X), 2600), QBColor(clr%)
                    ElseIf Q = 6 Then
                        clr% = 1
                        Line (xPos1(Y), 900)-(xPos2(X), 2600), QBColor(clr%)
                    End If
                ElseIf optopt% = 1 Then
                    AstrLine.Caption = "Synastry - sextiles (blue) and trines (green)"
                    If Q = 3 Then
                        clr% = 1
                        Line (xPos1(Y), 900)-(xPos2(X), 2600), QBColor(clr%)
                    ElseIf Q = 5 Then
                        clr% = 10
                        Line (xPos1(Y), 900)-(xPos2(X), 2600), QBColor(clr%)
                    End If
                Else
                    AstrLine.Caption = "Synastry - conjunctions"
                    If Q = 2 Then
                        clr% = 0
                        Line (xPos1(Y), 900)-(xPos2(X), 2600), QBColor(clr%)
                    End If
                End If
            End If
fp1b:
        Next X
fp1a:
    Next Y
End Sub

Private Sub Form_Resize()
    If NoDo% = 0 Then
        Form_Paint
    End If
End Sub
