VERSION 5.00
Begin VB.Form wheels_90
   AutoRedraw      =   -1  'True
   Caption         =   "90 deg Chartwheels"
   ClientHeight    =   6225
   ClientLeft      =   1185
   ClientTop       =   915
   ClientWidth     =   8160
   BeginProperty Font
      Name            =   "Horary"
      Size            =   9
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H00000000&
   Icon            =   "wheels_90.frx":0000
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   568.409
   ScaleLeft       =   -400
   ScaleMode       =   0  'User
   ScaleTop        =   300
   ScaleWidth      =   857.579
   Begin VB.Line Line2
      X1              =   -0.007
      X2              =   -0.007
      Y1              =   423.269
      Y2              =   782.12
   End
   Begin VB.Line Line1
      X1              =   -210.828
      X2              =   225.108
      Y1              =   599.956
      Y2              =   599.956
   End
   Begin VB.Menu mnuDisplaySymbols
      Caption         =   "&Display symbols"
   End
   Begin VB.Menu mnuUseList1
      Caption         =   "Use planet list #1"
   End
   Begin VB.Menu mnuUseList2
      Caption         =   "Use planet list #2"
   End
   Begin VB.Menu mnuUseList3
      Caption         =   "Use planet list #3"
   End
   Begin VB.Menu mnuPrintChartwheel
      Caption         =   "&Print"
   End
   Begin VB.Menu mnuHelp
      Caption         =   "&Help"
   End
End
Attribute VB_Name = "wheels_90"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private iBKMode As Long

'variables added/changed for 90 deg wheels
'Global CWHC_90(13), CWPlanets_90(), CWPlanetAngle_90()
'Global StartScale_90%, WheelType_90%, NoDo_90%, NotDo_90%, PrntObj_90%
'Global WheelBackground_90%
'Global Wheels1Captions_90$(), Wheels2Captions_90$()
'Global NatORSyn_90%, InnerOuter_90%, NatOrTranOuter_90%, OuterPH_90$

Private Const TRANSPARENT = 1

Private Sub AdjustNCH1()
    If XOPTION!(75) >= XOPTION!(193) Then
        NumeralCharacterHeight% = NumeralCharacterHeight% - XOPTION!(194) 'for screen planet minutes
    End If
End Sub

Private Sub AdjustNCHP1()
    If Angle > 75 And Angle < 310 Then Exit Sub
    If XOPTION!(199) = 0 Or NatORSyn_90% <> 2 Then
        If XOPTION!(85) >= XOPTION!(195) Then
            NumeralCharacterHeight% = NumeralCharacterHeight% - XOPTION!(196) 'for printer planet minutes
        End If
    Else
        If (XOPTION!(203) >= XOPTION!(195)) Or (WheelType_90% = 3 And InnerOuter_90% = 0 And HOUSEY = 8) Then
            NumeralCharacterHeight% = NumeralCharacterHeight% - XOPTION!(196) 'for printer planet minutes
        End If
    End If
End Sub

Private Sub BoldGTENS()
    FontBold = True: Call GTENS: FontBold = False
End Sub

Private Sub BoldGTENSPrinter()
    Printer.FontBold = True: Call GTENSPrinter: Printer.FontBold = False
End Sub

Private Sub BoldGTENSX()
    FontBold = True: Call GTENSX: FontBold = False
End Sub

Private Sub BoldGTENSXPrinter()
    Printer.FontBold = True: Call GTENSXPrinter: Printer.FontBold = False
End Sub

Private Sub BoldGUNITS()
    FontBold = True: Call GUNITS: FontBold = False
End Sub

Private Sub BoldGUNITSPrinter()
    Printer.FontBold = True: Call GUNITSPrinter: Printer.FontBold = False
End Sub

Private Sub ChangeRadiusForGlyph()
    COL = COL - (GlyphCharacterWidth% * Cosine(Angle))
    If PrntObj_90% = 0 Then
        ROW = ROW - (GlyphCharacterHeight% / (640 / 480) * Sine(Angle))
        CurrentY = ROW: CurrentX = COL
    Else
        ROW = ROW - (GlyphCharacterHeight% / (600 / 480) * Sine(Angle))
        Printer.CurrentY = ROW: Printer.CurrentX = COL
    End If
End Sub

Private Sub ChangeRadiusForNumeral()
    COL = COL - (NumeralCharacterWidth% * Cosine(Angle))
    If PrntObj_90% = 0 Then
        ROW = ROW - (NumeralCharacterHeight% / (640 / 480) * Sine(Angle))
        CurrentY = ROW: CurrentX = COL
    Else
        ROW = ROW - (NumeralCharacterHeight% / (600 / 480) * Sine(Angle))
        Printer.CurrentY = ROW: Printer.CurrentX = COL
    End If
End Sub

Private Sub CountPlanets()
'count the number of planets in each house
        Dim X, z%

        For X = 1 To num_pl_bodies_90%: 'was 10
            temp = Val(Mid$(ph$, SORTPOS(X) * 10 - 9, 2))
            NOPIH(temp) = NOPIH(temp) + 1: HOME(X) = temp
        Next X
'sort and analyze all the data
SHT2:   If HOME(num_pl_bodies_90%) = HOME(1) Then
            TEMP1X = SORT(num_pl_bodies_90%): TEMP2X = SORTPOS(num_pl_bodies_90%): TEMP3X = HOME(num_pl_bodies_90%)
            For X = num_pl_bodies_90% To 2 Step -1: 'was 10
                SORT(X) = SORT(X - 1): SORTPOS(X) = SORTPOS(X - 1): HOME(X) = HOME(X - 1)
            Next X
            SORT(1) = TEMP1X: SORTPOS(1) = TEMP2X: HOME(1) = TEMP3X
            GoTo SHT2
        End If
        HOUSEY = 0

        For z% = 0 To 200           'was 115
            SpotFilled%(z%) = 0
        Next z%
End Sub

Private Sub DrawDualChartwheel()
    Dim clr%, clr_5deg%
    Dim vr2 As Single

    vr2 = 0.9875

    clr% = XOPTION!(102): If WheelBackground_90% <> 0 Then clr% = QBColor(0)
    clr_5deg% = XOPTION!(122): If WheelBackground_90% <> 0 Then clr_5deg% = QBColor(0)

    If XOPTION!(50) >= 1 Then
        'marks every 1 degree
        For X3 = PI / 2 To (2 * PI - PI / 45) + PI / 2 Step PI / 45
            Line (212 * Cos(X3), vr2 * 212 * Sin(X3))-(217 * Cos(X3), vr2 * 217 * Sin(X3)), QBColor(clr%)
        Next X3

        'marks every 5 degrees
        For X3 = PI / 2 To (2 * PI - PI / 9) + PI / 2 Step PI / 9
            Line (207 * Cos(X3), vr2 * 207 * Sin(X3))-(217 * Cos(X3), vr2 * 217 * Sin(X3)), QBColor(clr_5deg%)
        Next X3
    Else
        For X3 = 0 To (2 * PI - PI / 6) Step PI / 6
            If WheelBackground_90% = 0 Then
                Circle (0, 0), 217, QBColor(XOPTION!(102)), -X3, -(X3 + PI / 6)
            Else
                Circle (0, 0), 217, QBColor(0), -X3, -(X3 + PI / 6)
            End If
        Next X3
    End If

    Circle (0, 0), 217, QBColor(XOPTION!(101))
    Circle (0, 0), 138, QBColor(XOPTION!(101))

    If XOPTION!(50) >= 1 Then
        'nothing
    Else
        Circle (0, 0), 62, QBColor(XOPTION!(101))
        Circle (0, 0), 40, QBColor(XOPTION!(101))

        FillColor = QBColor(XOPTION!(100))
        If WheelBackground_90% = 1 Then FillColor = QBColor(15)

        FillStyle = 0: Circle (0, 0), 40: FillStyle = 1

        Circle (0, 0), 40, QBColor(XOPTION!(101))
    End If
End Sub

Private Sub DrawDualChartwheelPrinter()
    Printer.Circle (0, 0), 217, QBColor(XOPTION!(115))
    Printer.Circle (0, 0), 138, QBColor(XOPTION!(115))

    If XOPTION!(50) >= 1 Then
        'nothing
    Else
        Printer.Circle (0, 0), 62, QBColor(XOPTION!(115))
        Printer.Circle (0, 0), 40, QBColor(XOPTION!(115))
    End If

    If XOPTION!(50) >= 1 Then
        For X3 = PI / 2 To (2 * PI - PI / 9) + PI / 2 Step PI / 9
            Printer.Line (207 * Cos(X3), 0.9475 * 207 * Sin(X3))-(217 * Cos(X3), 0.9475 * 217 * Sin(X3)), QBColor(XOPTION!(116))
        Next X3
        For X3 = PI / 2 To (2 * PI - PI / 45) + PI / 2 Step PI / 45
            Printer.Line (212 * Cos(X3), 0.9475 * 212 * Sin(X3))-(217 * Cos(X3), 0.9475 * 217 * Sin(X3)), QBColor(XOPTION!(116))
        Next X3
    Else
        For X3 = 0 To (2 * PI - PI / 6) Step PI / 6
            Printer.Line (40 * Cos(X3), 0.9475 * 40 * Sin(X3))-(217 * Cos(X3), 0.9475 * 217 * Sin(X3)), QBColor(XOPTION!(116))
        Next X3
    End If
End Sub

Private Sub DrawSingleChartwheel()
    Dim clr%, clr_5deg%, HC3(), X, dist, x4
    Dim inner_radius%, outer_radius%
    Dim vr2

    inner_radius% = 120
    outer_radius% = 217
    vr2 = 0.9875

    clr% = XOPTION!(102): If WheelBackground_90% <> 0 Then clr% = QBColor(0)
    clr_5deg% = XOPTION!(122): If WheelBackground_90% <> 0 Then clr_5deg% = QBColor(0)

    If XOPTION!(50) >= 1 Then
        For X3 = PI / 2 To (2 * PI - PI / 45) + PI / 2 Step PI / 45
            'marks every 1 degree
            Line (212 * Cos(X3), vr2 * 212 * Sin(X3))-(outer_radius% * Cos(X3), vr2 * outer_radius% * Sin(X3)), QBColor(clr%)
        Next X3
        For X3 = PI / 2 To (2 * PI - PI / 9) + PI / 2 Step PI / 9
            'marks every 5 degrees
            Line (207 * Cos(X3), vr2 * 207 * Sin(X3))-(outer_radius% * Cos(X3), vr2 * outer_radius% * Sin(X3)), QBColor(clr_5deg%)
        Next X3
    Else
        For X3 = 0 To (2 * PI - PI / 6) Step PI / 6
            Line (inner_radius% * Cos(X3), vr2 * inner_radius% * Sin(X3))-(outer_radius% * Cos(X3), vr2 * outer_radius% * Sin(X3)), QBColor(clr%)
        Next X3
    End If

    Circle (0, 0), outer_radius%, QBColor(XOPTION!(101))
    Circle (0, 0), inner_radius%, QBColor(XOPTION!(101))
End Sub

Private Sub DrawSingleChartwheelPrinter()
    Dim clr%, HC3(), X, dist, x4

    Printer.Circle (0, 0), 217, QBColor(XOPTION!(115))
    Printer.Circle (0, 0), 120, QBColor(XOPTION!(115))
    clr% = XOPTION!(116)

    If XOPTION!(50) >= 1 Then
        For X3 = PI / 2 To (2 * PI - PI / 9) + PI / 2 Step PI / 9
            Printer.Line (207 * Cos(X3), 0.9475 * 207 * Sin(X3))-(217 * Cos(X3), 0.9475 * 217 * Sin(X3)), QBColor(clr%)
        Next X3
        For X3 = PI / 2 To (2 * PI - PI / 45) + PI / 2 Step PI / 45
            Printer.Line (212 * Cos(X3), 0.9475 * 212 * Sin(X3))-(217 * Cos(X3), 0.9475 * 217 * Sin(X3)), QBColor(clr%)
        Next X3
    Else
        For X3 = 0 To (2 * PI - PI / 6) Step PI / 6
            Printer.Line (120 * Cos(X3), 0.9475 * 120 * Sin(X3))-(217 * Cos(X3), 0.9475 * 217 * Sin(X3)), QBColor(clr%)
        Next X3
    End If
End Sub

Private Sub FindDegreesInEachHouse()
    Dim X

    For X = 1 To 12
        HC1(X) = CWHC_90(X)
    Next X

    For X = 1 To 11
        DegEachHouse(X) = CRUNCH(HC1(X + 1) - HC1(X))
        If DegEachHouse(X) = 277.5 Then
            DegEachHouse(X) = 7.5
        End If
    Next X

    DegEachHouse(12) = CRUNCH(HC1(1) - HC1(12))
    If DegEachHouse(12) = 277.5 Then
        DegEachHouse(12) = 7.5
    End If
End Sub

Private Sub Form_Deactivate()
    If wheels_90.WindowState <> 1 Then
        If DontDo% = 0 Then
            wheels_90WindowHeight% = wheels_90.Height
            wheels_90WindowWidth% = wheels_90.Width
            wheels_90WindowTop% = wheels_90.Top
            wheels_90WindowLeft% = wheels_90.Left
        End If
    End If
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    Dim outer_radius%

    outer_radius% = 208

    If KeyCode = 40 Then
        Me!Line1.Visible = False
        Me!Line2.Visible = False

        angle_line1% = 0
        angle_line2% = 90

        Exit Sub
    ElseIf KeyCode = 39 Then
        'right arrow
        angle_line1% = angle_line1% + 2
        angle_line2% = angle_line2% + 2

        If angle_line1% >= 360 Then angle_line1% = angle_line1% - 360
        If angle_line2% >= 360 Then angle_line2% = angle_line2% - 360
    ElseIf KeyCode = 37 Then
        'left arrow
        angle_line1% = angle_line1% - 2
        angle_line2% = angle_line2% - 2

        If angle_line1% < 0 Then angle_line1% = angle_line1% + 360
        If angle_line2% < 0 Then angle_line2% = angle_line2% + 360
    Else
        Exit Sub
    End If

    'Line1.Visible = False
    Line1.x1 = -outer_radius% * Cosine(angle_line1%)
    Line1.x2 = outer_radius% * Cosine(angle_line1%)
    Line1.y1 = outer_radius% * Sine(angle_line1%)
    Line1.y2 = -outer_radius% * Sine(angle_line1%)
    Line1.Visible = True

    'Line2.Visible = False
    Line2.x1 = outer_radius% * Cosine(angle_line2%)
    Line2.x2 = -outer_radius% * Cosine(angle_line2%)
    Line2.y1 = -outer_radius% * Sine(angle_line2%)
    Line2.y2 = outer_radius% * Sine(angle_line2%)
    Me!Line2.Visible = True
End Sub

Private Sub Form_KeyPress(KeyAscii As Integer)
    If KeyAscii = 27 Then
        AstroSrc.SetFocus
        KeyAscii = 0
    End If
End Sub

Private Sub Form_Load()
    wheels_90.ScaleWidth = 1024
    wheels_90.ScaleHeight = 768

    NoDo_90% = 1
    wheels_90.Top = wheels_90WindowTop%
    wheels_90.Left = wheels_90WindowLeft%
    wheels_90.Height = wheels_90WindowHeight%
    wheels_90.Width = wheels_90WindowWidth%
    NoDo_90% = 0

    For cwX = 1 To num_pl_bodies_90%
        CWPlanets_90(cwX) = Planets(cwX)
    Next cwX

    For cwX = 1 To 12
        CWHC_90(cwX) = HC(cwX)
    Next cwX

    CWRetrograde$ = Retrograde_90$

'in Astro123 leaving this here rather than below causes Form_Paint to run twice, not one (01/26/2003).
    'wheels_90.Top = 0: WheelBackground_90% = 0
'    NoDo_90% = 1
'    wheels_90.Top = 0: WheelBackground_90% = 0
'    wheels_90.Width = MasterWidth
'    wheels_90.Height = MasterHeight
'    NoDo_90% = 0

''    wheels_90.ScaleWidth = MasterScaleWidth
''    wheels_90.ScaleHeight = MasterScaleHeight

'    wheels_90.ScaleWidth = 1024
'    wheels_90.ScaleHeight = 768

    If InputD1!chk2ndPerson.Value = 0 Or WheelType_90% <> 2 Then
        NatOrTranOuter_90% = 0
    End If

    angle_line1% = 0
    angle_line2% = 90

    Line1.x1 = -outer_radius% / 2
    Line1.x2 = outer_radius% / 2
    Line1.y1 = outer_radius% / 2
    Line1.y2 = -outer_radius% / 2

    Line2.x1 = outer_radius% / 2
    Line2.x2 = -outer_radius% / 2
    Line2.y1 = -outer_radius% / 2
    Line2.y2 = outer_radius% / 2
End Sub

Private Sub Form_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button = 2 Then AstroSrc.SetFocus
End Sub

Private Sub Form_Paint()
    Dim a13%, X3, ab1, ab2, ab3, ab4

    If wheels_90.WindowState = 1 Then Exit Sub

    OuterWheelRadius% = 200

    If PrntObj_90% = 0 Then
        wheels_90.Cls
        wheels_90.Scale (-StartScale_90%, StartScale_90% * Abs(wheels_90.ScaleHeight / wheels_90.ScaleWidth))-(StartScale_90%, -StartScale_90% * Abs(wheels_90.ScaleHeight / wheels_90.ScaleWidth))
        wheels_90.BackColor = QBColor(XOPTION!(100))
        If WheelBackground_90% = 1 Then wheels_90.BackColor = QBColor(15)
        wheels_90.ForeColor = RGB(0, 0, 0)
        If NatORSyn_90% = 0 Then
            Call DrawSingleChartwheel
        Else
            Call DrawDualChartwheel
        End If

'set font and size for house markings
        wheels_90.FontName = "Astro_90"
        wheels_90.FontSize = XOPTION!(69): 'was WheelFontScale%
'put house numbers 1 - 12 in each houses space
        If NatORSyn_90% <> 0 Then
            Call MarkHouseNumbersTriple
        End If

        Call FindDegreesInEachHouse
        Call PutDataOnHouseCusps

        wheels_90.FontName = "Astro_90"
        wheels_90.FontSize = XOPTION!(72): 'was PlanetFontScale%: 'font size for planet degrees
        GlyphCharacterWidth% = wheels_90.TextWidth(Chr$(236)) + XOPTION!(60)
        GlyphCharacterHeight% = Abs(wheels_90.TextHeight(Chr$(236))) + XOPTION!(62)
        NumeralCharacterWidth% = wheels_90.TextWidth(Chr$(48)) + XOPTION!(61)
        NumeralCharacterHeight% = Abs(wheels_90.TextHeight(Chr$(48))) + XOPTION!(63)

        InnerOuter_90% = 1

        Call SetupAndDisplayPlanets

        If NatORSyn_90% <> 0 Then
            InnerOuter_90% = 0
            Call SetupAndDisplayPlanets
        End If
        Call PlaceWheelCaptions
    Else
        StartScale_90% = 265

        Printer.ForeColor = RGB(0, 0, 0)

        ab1 = -StartScale_90%
        ab2 = StartScale_90% / (480 / 600) - 56
        ab3 = StartScale_90%
        ab4 = -StartScale_90% / (480 / 600) - 56
        ab1 = ab1 * 0.9475
        ab2 = ab2 * 0.9475
        ab3 = ab3 * 0.9475
        ab4 = ab4 * 0.9475

        Printer.Scale (ab1, ab2)-(ab3, ab4)
        If NatORSyn_90% = 0 Then
            Call DrawSingleChartwheelPrinter
        Else
            Call DrawDualChartwheelPrinter
        End If
'set font and size for house markings
        Printer.FontName = "Astro_90"
        Printer.FontSize = XOPTION!(79): 'font size for house cusps
        Printer.FontBold = False
'put house numbers 1 - 12 in each houses space
        If NatORSyn_90% = 1 Then
            Call MarkHouseNumbersTriplePrinter
        End If

        Call FindDegreesInEachHouse
        Call PutDataOnHouseCuspsPrinter

        Printer.FontName = "Astro_90"
        If XOPTION!(199) = 0 Or NatORSyn_90% <> 2 Then
            Printer.FontSize = XOPTION!(82): 'font size for planet degrees
        Else
            Printer.FontSize = XOPTION!(200)
        End If

        GlyphCharacterWidth% = Printer.TextWidth(Chr$(236)) + XOPTION!(64): 'the Sun
        GlyphCharacterHeight% = Abs(Printer.TextHeight(Chr$(236))) + XOPTION!(66): 'the Sun
        NumeralCharacterWidth% = Printer.TextWidth(Chr$(48)) + XOPTION!(65): 'the number 0
        NumeralCharacterHeight% = Abs(Printer.TextHeight(Chr$(48))) + XOPTION!(67): 'the number 0

        InnerOuter_90% = 1

        Call SetupAndDisplayPlanets

        If NatORSyn_90% <> 0 Then
            InnerOuter_90% = 0
            Call SetupAndDisplayPlanets
        End If

        Call PlaceWheelCaptionsPrinter
    End If
End Sub

Private Sub Form_Resize()
    If Abs(ScaleHeight) <= Abs(ScaleWidth) Then
        StartScale_90% = 225 / Abs(wheels_90.ScaleHeight / wheels_90.ScaleWidth): '238
    Else
        StartScale_90% = 244
    End If

    If NoDo_90% = 0 Then
        Form_Paint
    End If
End Sub

Private Sub GPLANETS()
    Dim t$

    If glyph_num%(SORTPOS(X)) > 223 Then
        wheels_90.Print Chr$(glyph_num%(SORTPOS(X)))
    Else
        t$ = Format$(glyph_num%(SORTPOS(X)) - 96, "00")
        wheels_90.Print t$
    End If
End Sub

Private Sub GPLANETSPrinter()
    Dim t$

    iBKMode = SetBkMode(Printer.hDC, TRANSPARENT)

    If glyph_num%(SORTPOS(X)) > 223 Then
        Printer.Print Chr$(glyph_num%(SORTPOS(X)))
    Else
        t$ = Format$(glyph_num%(SORTPOS(X)) - 96, "00")
        Printer.Print t$
    End If
End Sub

Private Sub GSIGNS()
    wheels_90.Print Chr$(191 + Q)
End Sub

Private Sub GSIGNSPrinter()
    iBKMode = SetBkMode(Printer.hDC, TRANSPARENT)
    Printer.Print Chr$(191 + Q)
End Sub

Private Sub GTENS()
        If Fix(AL / 10) = 0 Then
            wheels_90.Print Chr$(32)
        Else
            wheels_90.Print Chr$(48 + Fix(AL / 10))
        End If
End Sub

Private Sub GTENSPrinter()
        If Fix(AL / 10) = 0 Then
            iBKMode = SetBkMode(Printer.hDC, TRANSPARENT)
            Printer.Print Chr$(32)
        Else
            iBKMode = SetBkMode(Printer.hDC, TRANSPARENT)
            Printer.Print Chr$(48 + Fix(AL / 10))
        End If
End Sub

Private Sub GTENSX()
        wheels_90.Print Chr$(48 + Fix(AL / 10))
End Sub

Private Sub GTENSXPrinter()
    iBKMode = SetBkMode(Printer.hDC, TRANSPARENT)
    Printer.Print Chr$(48 + Fix(AL / 10))
End Sub

Private Sub GUNITS()
        wheels_90.Print Chr$(48 + AL Mod 10)
End Sub

Private Sub GUNITSPrinter()
    iBKMode = SetBkMode(Printer.hDC, TRANSPARENT)
    Printer.Print Chr$(48 + AL Mod 10)
End Sub

Private Sub MarkHouseNumbersTriple()
    If XOPTION!(50) >= 1 Then Exit Sub

    CurrentX = -52: CurrentY = -6:  '1st house
    wheels_90.Print Chr$(49)

    CurrentX = -40: CurrentY = -30:  '2nd house
    wheels_90.Print Chr$(50)

    CurrentX = -16: CurrentY = -44:  '3rd house
    wheels_90.Print Chr$(51)

    CurrentX = 10: CurrentY = -44:  '4th house
    wheels_90.Print Chr$(52)

    CurrentX = 32: CurrentY = -30:  '5th house
    wheels_90.Print Chr$(53)

    CurrentX = 46: CurrentY = -6:  '6th house
    wheels_90.Print Chr$(54)

    CurrentX = 46: CurrentY = 18:  '7th house
    wheels_90.Print Chr$(55)

    CurrentX = 32: CurrentY = 40:  '8th house
    wheels_90.Print Chr$(56)

    CurrentX = 10: CurrentY = 52:  '9th house
    wheels_90.Print Chr$(57)

    CurrentX = -20: CurrentY = 52:  '10th house
    wheels_90.Print Chr$(49)
    CurrentX = -12: CurrentY = 52
    wheels_90.Print Chr$(48)

    CurrentX = -44: CurrentY = 40:  '11th house
    wheels_90.Print Chr$(49)
    CurrentX = -36: CurrentY = 40
    wheels_90.Print Chr$(49)

    CurrentX = -56: CurrentY = 18:  '12th house
    wheels_90.Print Chr$(49)
    CurrentX = -48: CurrentY = 18
    wheels_90.Print Chr$(50)
End Sub

Private Sub MarkHouseNumbersTriplePrinter()
    If XOPTION!(50) >= 1 Then Exit Sub

    Printer.CurrentX = -52: Printer.CurrentY = -6:  '1st house
    iBKMode = SetBkMode(Printer.hDC, TRANSPARENT)
    Printer.Print Chr$(49)

    Printer.CurrentX = -40: Printer.CurrentY = -30:  '2nd house
    iBKMode = SetBkMode(Printer.hDC, TRANSPARENT)
    Printer.Print Chr$(50)

    Printer.CurrentX = -16: Printer.CurrentY = -44:  '3rd house
    iBKMode = SetBkMode(Printer.hDC, TRANSPARENT)
    Printer.Print Chr$(51)

    Printer.CurrentX = 10: Printer.CurrentY = -44:  '4th house
    iBKMode = SetBkMode(Printer.hDC, TRANSPARENT)
    Printer.Print Chr$(52)

    Printer.CurrentX = 32: Printer.CurrentY = -30:  '5th house
    iBKMode = SetBkMode(Printer.hDC, TRANSPARENT)
    Printer.Print Chr$(53)

    Printer.CurrentX = 46: Printer.CurrentY = -6:  '6th house
    iBKMode = SetBkMode(Printer.hDC, TRANSPARENT)
    Printer.Print Chr$(54)

    Printer.CurrentX = 46: Printer.CurrentY = 18:  '7th house
    iBKMode = SetBkMode(Printer.hDC, TRANSPARENT)
    Printer.Print Chr$(55)

    Printer.CurrentX = 32: Printer.CurrentY = 40:  '8th house
    iBKMode = SetBkMode(Printer.hDC, TRANSPARENT)
    Printer.Print Chr$(56)

    Printer.CurrentX = 10: Printer.CurrentY = 52:  '9th house
    iBKMode = SetBkMode(Printer.hDC, TRANSPARENT)
    Printer.Print Chr$(57)

    Printer.CurrentX = -20: Printer.CurrentY = 52:  '10th house
    iBKMode = SetBkMode(Printer.hDC, TRANSPARENT)
    Printer.Print Chr$(49)
    Printer.CurrentX = -12: Printer.CurrentY = 52
    iBKMode = SetBkMode(Printer.hDC, TRANSPARENT)
    Printer.Print Chr$(48)

    Printer.CurrentX = -44: Printer.CurrentY = 40:  '11th house
    iBKMode = SetBkMode(Printer.hDC, TRANSPARENT)
    Printer.Print Chr$(49)
    Printer.CurrentX = -36: Printer.CurrentY = 40
    iBKMode = SetBkMode(Printer.hDC, TRANSPARENT)
    Printer.Print Chr$(49)

    Printer.CurrentX = -56: Printer.CurrentY = 18:  '12th house
    iBKMode = SetBkMode(Printer.hDC, TRANSPARENT)
    Printer.Print Chr$(49)
    Printer.CurrentX = -48: Printer.CurrentY = 18
    iBKMode = SetBkMode(Printer.hDC, TRANSPARENT)
    Printer.Print Chr$(50)
End Sub

Private Sub mnuDisplaySymbols_Click()
    Unload display_symbols
    display_symbols.Show vbModeless, AstroSrc
End Sub

Private Sub mnuHelp_Click()
    CurrentHelpFile$ = "\wheel_90.HLP"
    Call DisplayHelp
End Sub

Private Sub mnuPrintChartwheel_Click()
    Dim Msg, DgDef, TITLE_X, Response, TempPS

    Msg = "Click 'YES' for full page chartwheel. Click 'NO' for half page chartwheel."
    DgDef = MB_YESNOCANCEL + MB_ICONQUESTION + MB_DEFBUTTON3
    TITLE_X = "Full page or half page chartwheel"
    Response = MsgBox(Msg, DgDef, TITLE_X)

    Screen.MousePointer = 11
    If Response = 6 Then
        PrntObj_90% = 1
        Printer.ScaleWidth = MasterScaleWidth
        Printer.ScaleHeight = MasterScaleWidth
        NatOrTranOuter_90% = 0: wheels_90.WindowState = 2
        Printer.EndDoc: PrntObj_90% = 0
    ElseIf Response = 7 Then
        WheelBackground_90% = 1
        PrntObj_90% = 0: wheels_90.WindowState = 2
        wheels_90.PrintForm
        WheelBackground_90% = 0
    End If
    wheels_90.WindowState = 0
    Screen.MousePointer = 0
End Sub

Private Sub PlaceWheelCaptions()
    Dim X%

    wheels_90.FontName = "Astro_90"
    wheels_90.FontSize = XOPTION!(68): 'was LegendFontScale%
    wheels_90.ForeColor = QBColor(XOPTION!(88))

    wheels_90.CurrentX = wheels_90.ScaleLeft + 10: wheels_90.CurrentY = wheels_90.ScaleTop: 'set to upper left hand corner
    For X% = 1 To 7
        wheels_90.Print Wheels1Captions_90$(X%): wheels_90.CurrentX = wheels_90.ScaleLeft + 10
    Next X%

    wheels_90.CurrentY = (wheels_90.ScaleHeight / 2) + (Abs(wheels_90.TextHeight(Wheels2Captions_90$(1))) * 8)

    For X% = 1 To 7
        wheels_90.Print Wheels2Captions_90$(X%): wheels_90.CurrentX = wheels_90.ScaleLeft + 10
    Next X%
End Sub

Private Sub PlaceWheelCaptionsPrinter()
    Dim X%, t$

    Printer.FontName = "Astro_90"
    Printer.FontSize = XOPTION!(78): 'LegendFontScale%
    Printer.FontBold = False
    Printer.ForeColor = QBColor(XOPTION!(103))

    Printer.CurrentX = Printer.ScaleLeft + 30
        Printer.CurrentY = Printer.ScaleTop - XOPTION!(243): 'set to upper left hand corner
    For X% = 1 To 7
        iBKMode = SetBkMode(Printer.hDC, TRANSPARENT)
        Printer.Print Wheels1Captions_90$(X%): Printer.CurrentX = Printer.ScaleLeft + 30
    Next X%

    Printer.CurrentY = (Printer.ScaleHeight / 2) + (Abs(Printer.TextHeight(Wheels2Captions_90$(1))) * XOPTION!(191))

    Printer.CurrentX = Printer.ScaleLeft + 30
    For X% = 1 To 7
        iBKMode = SetBkMode(Printer.hDC, TRANSPARENT)
        Printer.Print Wheels2Captions_90$(X%): Printer.CurrentX = Printer.ScaleLeft + 30
    Next X%

    If XOPTION!(174) = 0 Then Exit Sub
'do personalized name thing
    Printer.FontSize = XOPTION!(175)
    Printer.ForeColor = QBColor(XOPTION!(176))
    Printer.CurrentY = Printer.ScaleTop - XOPTION!(244): 'set to top line

    Close #2
    On Error GoTo pnt1a
    Open DefaultDirectory + "\PERSONAL.NAM" For Input As #2
    Do While Not EOF(2)
       Line Input #2, t$
       Printer.CurrentX = (Printer.ScaleWidth / 2) - XOPTION!(177) - Printer.TextWidth(t$)
       iBKMode = SetBkMode(Printer.hDC, TRANSPARENT)
       Printer.Print t$
    Loop
pnt1a:
    Close #2: Exit Sub
End Sub

Private Sub PutDataOnHouseCusps()
    Dim temp, t, t1, t2, t3, t4, t5, dist

If XOPTION!(50) >= 1 Then
'00/90 degrees
        wheels_90.FontSize = XOPTION!(123): wheels_90.ForeColor = QBColor(XOPTION!(89))
        z = 0: Call Convert360toDM
        CurrentX = -2: CurrentY = 220
        AL = z: Call BoldGTENSX
        CurrentX = 1: CurrentY = 220
        AL = z: Call BoldGUNITS

'85 degrees
        wheels_90.FontSize = XOPTION!(123): wheels_90.ForeColor = QBColor(XOPTION!(89))
        z = 85: Call Convert360toDM
        CurrentX = 73: CurrentY = 207
        AL = z: Call BoldGTENSX
        CurrentX = 76: CurrentY = 207
        AL = z: Call BoldGUNITS

'80 degrees
        wheels_90.FontSize = XOPTION!(123): wheels_90.ForeColor = QBColor(XOPTION!(89))
        z = 80: Call Convert360toDM
        CurrentX = 140: CurrentY = 170
        AL = z: Call BoldGTENSX
        CurrentX = 143: CurrentY = 170
        AL = z: Call BoldGUNITS

'75 degrees
        wheels_90.FontSize = XOPTION!(123): wheels_90.ForeColor = QBColor(XOPTION!(89))
        z = 75: Call Convert360toDM
        CurrentX = 190: CurrentY = 111
        AL = z: Call BoldGTENSX
        CurrentX = 193: CurrentY = 111
        AL = z: Call BoldGUNITS

'70 degrees
        wheels_90.FontSize = XOPTION!(123): wheels_90.ForeColor = QBColor(XOPTION!(89))
        z = 70: Call Convert360toDM
        CurrentX = 217: CurrentY = 40
        AL = z: Call BoldGTENSX
        CurrentX = 220: CurrentY = 40
        AL = z: Call BoldGUNITS

'65 degrees
        wheels_90.FontSize = XOPTION!(123): wheels_90.ForeColor = QBColor(XOPTION!(89))
        z = 65: Call Convert360toDM
        CurrentX = 217: CurrentY = -36
        AL = z: Call BoldGTENSX
        CurrentX = 220: CurrentY = -36
        AL = z: Call BoldGUNITS

'60 degrees
        wheels_90.FontSize = XOPTION!(123): wheels_90.ForeColor = QBColor(XOPTION!(89))
        z = 60: Call Convert360toDM
        CurrentX = 190: CurrentY = -108
        AL = z: Call BoldGTENSX
        CurrentX = 193: CurrentY = -108
        AL = z: Call BoldGUNITS

'55 degrees
        wheels_90.FontSize = XOPTION!(123): wheels_90.ForeColor = QBColor(XOPTION!(89))
        z = 55: Call Convert360toDM
        CurrentX = 140: CurrentY = -165
        AL = z: Call BoldGTENSX
        CurrentX = 143: CurrentY = -165
        AL = z: Call BoldGUNITS

'50 degrees
        wheels_90.FontSize = XOPTION!(123): wheels_90.ForeColor = QBColor(XOPTION!(89))
        z = 50: Call Convert360toDM
        CurrentX = 73: CurrentY = -204
        AL = z: Call BoldGTENSX
        CurrentX = 76: CurrentY = -204
        AL = z: Call BoldGUNITS

'45 degrees
        wheels_90.FontSize = XOPTION!(123): wheels_90.ForeColor = QBColor(XOPTION!(89))
        z = 45: Call Convert360toDM
        CurrentX = -2: CurrentY = -216
        AL = z: Call BoldGTENSX
        CurrentX = 1: CurrentY = -216
        AL = z: Call BoldGUNITS

'40 degrees
        wheels_90.FontSize = XOPTION!(123): wheels_90.ForeColor = QBColor(XOPTION!(89))
        z = 40: Call Convert360toDM
        CurrentX = -79: CurrentY = -204
        AL = z: Call BoldGTENSX
        CurrentX = -76: CurrentY = -204
        AL = z: Call BoldGUNITS

'35 degrees
        wheels_90.FontSize = XOPTION!(123): wheels_90.ForeColor = QBColor(XOPTION!(89))
        z = 35: Call Convert360toDM
        CurrentX = -147: CurrentY = -165
        AL = z: Call BoldGTENSX
        CurrentX = -144: CurrentY = -165
        AL = z: Call BoldGUNITS

'30 degrees
        wheels_90.FontSize = XOPTION!(123): wheels_90.ForeColor = QBColor(XOPTION!(89))
        z = 30: Call Convert360toDM
        CurrentX = -196: CurrentY = -108
        AL = z: Call BoldGTENSX
        CurrentX = -193: CurrentY = -108
        AL = z: Call BoldGUNITS

'25 degrees
        wheels_90.FontSize = XOPTION!(123): wheels_90.ForeColor = QBColor(XOPTION!(89))
        z = 25: Call Convert360toDM
        CurrentX = -224: CurrentY = -37
        AL = z: Call BoldGTENSX
        CurrentX = -221: CurrentY = -37
        AL = z: Call BoldGUNITS

'20 degrees
        wheels_90.FontSize = XOPTION!(123): wheels_90.ForeColor = QBColor(XOPTION!(89))
        z = 20: Call Convert360toDM
        CurrentX = -224: CurrentY = 42
        AL = z: Call BoldGTENSX
        CurrentX = -221: CurrentY = 42
        AL = z: Call BoldGUNITS

'15 degrees
        wheels_90.FontSize = XOPTION!(123): wheels_90.ForeColor = QBColor(XOPTION!(89))
        z = 15: Call Convert360toDM
        CurrentX = -196: CurrentY = 112
        AL = z: Call BoldGTENSX
        CurrentX = -193: CurrentY = 112
        AL = z: Call BoldGUNITS

'10 degrees
        wheels_90.FontSize = XOPTION!(123): wheels_90.ForeColor = QBColor(XOPTION!(89))
        z = 10: Call Convert360toDM
        CurrentX = -147: CurrentY = 170
        AL = z: Call BoldGTENSX
        CurrentX = -144: CurrentY = 170
        AL = z: Call BoldGUNITS

'5 degrees
        wheels_90.FontSize = XOPTION!(123): wheels_90.ForeColor = QBColor(XOPTION!(89))
        z = 5: Call Convert360toDM
        CurrentX = -79: CurrentY = 207
        AL = z: Call BoldGTENSX
        CurrentX = -76: CurrentY = 207
        AL = z: Call BoldGUNITS
Else
    For t = 1 To 12
        wheels_90.FontSize = XOPTION!(69): wheels_90.ForeColor = QBColor(XOPTION!(89))
        z = HC1(t): Call Convert360toDM
        CurrentX = HCUSPDATA%(t * 10 - 10): CurrentY = HCUSPDATA%(t * 10 - 9)
        AL = z1: Call BoldGTENSX
        CurrentX = HCUSPDATA%(t * 10 - 8): CurrentY = HCUSPDATA%(t * 10 - 7)
        AL = z1: Call BoldGUNITS
        CurrentX = HCUSPDATA%(t * 10 - 6): CurrentY = HCUSPDATA%(t * 10 - 5)
        wheels_90.FontSize = XOPTION!(70): wheels_90.ForeColor = QBColor(XOPTION!(90))
        Call GSIGNS: wheels_90.ForeColor = QBColor(XOPTION!(91))
        wheels_90.FontSize = XOPTION!(71)
        CurrentX = HCUSPDATA%(t * 10 - 4): CurrentY = HCUSPDATA%(t * 10 - 3)
        AL = z2: Call GTENSX
        CurrentX = HCUSPDATA%(t * 10 - 2): CurrentY = HCUSPDATA%(t * 10 - 1)
        AL = z2: Call GUNITS
    Next t
End If
End Sub

Private Sub PutDataOnHouseCuspsPrinter()
    Dim t, t1, t2, t3, t4, t5, dist

If XOPTION!(50) >= 1 Then
        Printer.FontSize = XOPTION!(69): Printer.ForeColor = QBColor(XOPTION!(89))
        z = 0: Call Convert360toDM
        Printer.CurrentX = -5: Printer.CurrentY = 220
        AL = z: Call BoldGTENSXPrinter
        Printer.CurrentX = 1: Printer.CurrentY = 220
        AL = z: Call BoldGUNITSPrinter

        Printer.FontSize = XOPTION!(69): Printer.ForeColor = QBColor(XOPTION!(89))
        z = 85: Call Convert360toDM
        Printer.CurrentX = 72: Printer.CurrentY = 208
        AL = z: Call BoldGTENSXPrinter
        Printer.CurrentX = 78: Printer.CurrentY = 208
        AL = z: Call BoldGUNITSPrinter

        Printer.FontSize = XOPTION!(69): Printer.ForeColor = QBColor(XOPTION!(89))
        z = 80: Call Convert360toDM
        Printer.CurrentX = 142: Printer.CurrentY = 172
        AL = z: Call BoldGTENSXPrinter
        Printer.CurrentX = 148: Printer.CurrentY = 172
        AL = z: Call BoldGUNITSPrinter

        Printer.FontSize = XOPTION!(69): Printer.ForeColor = QBColor(XOPTION!(89))
        z = 75: Call Convert360toDM
        Printer.CurrentX = 192: Printer.CurrentY = 112
        AL = z: Call BoldGTENSXPrinter
        Printer.CurrentX = 198: Printer.CurrentY = 112
        AL = z: Call BoldGUNITSPrinter

        Printer.FontSize = XOPTION!(69): Printer.ForeColor = QBColor(XOPTION!(89))
        z = 70: Call Convert360toDM
        Printer.CurrentX = 218: Printer.CurrentY = 43
        AL = z: Call BoldGTENSXPrinter
        Printer.CurrentX = 224: Printer.CurrentY = 43
        AL = z: Call BoldGUNITSPrinter

        Printer.FontSize = XOPTION!(69): Printer.ForeColor = QBColor(XOPTION!(89))
        z = 65: Call Convert360toDM
        Printer.CurrentX = 216: Printer.CurrentY = -35
        AL = z: Call BoldGTENSXPrinter
        Printer.CurrentX = 222: Printer.CurrentY = -35
        AL = z: Call BoldGUNITSPrinter

        Printer.FontSize = XOPTION!(69): Printer.ForeColor = QBColor(XOPTION!(89))
        z = 60: Call Convert360toDM
        Printer.CurrentX = 190: Printer.CurrentY = -104
        AL = z: Call BoldGTENSXPrinter
        Printer.CurrentX = 196: Printer.CurrentY = -104
        AL = z: Call BoldGUNITSPrinter

        Printer.FontSize = XOPTION!(69): Printer.ForeColor = QBColor(XOPTION!(89))
        z = 55: Call Convert360toDM
        Printer.CurrentX = 138: Printer.CurrentY = -162
        AL = z: Call BoldGTENSXPrinter
        Printer.CurrentX = 144: Printer.CurrentY = -162
        AL = z: Call BoldGUNITSPrinter

        Printer.FontSize = XOPTION!(69): Printer.ForeColor = QBColor(XOPTION!(89))
        z = 50: Call Convert360toDM
        Printer.CurrentX = 70: Printer.CurrentY = -200
        AL = z: Call BoldGTENSXPrinter
        Printer.CurrentX = 76: Printer.CurrentY = -200
        AL = z: Call BoldGUNITSPrinter

        Printer.FontSize = XOPTION!(69): Printer.ForeColor = QBColor(XOPTION!(89))
        z = 45: Call Convert360toDM
        Printer.CurrentX = -5: Printer.CurrentY = -212
        AL = z: Call BoldGTENSXPrinter
        Printer.CurrentX = 1: Printer.CurrentY = -212
        AL = z: Call BoldGUNITSPrinter

        Printer.FontSize = XOPTION!(69): Printer.ForeColor = QBColor(XOPTION!(89))
        z = 40: Call Convert360toDM
        Printer.CurrentX = -82: Printer.CurrentY = -200
        AL = z: Call BoldGTENSXPrinter
        Printer.CurrentX = -76: Printer.CurrentY = -200
        AL = z: Call BoldGUNITSPrinter

        Printer.FontSize = XOPTION!(69): Printer.ForeColor = QBColor(XOPTION!(89))
        z = 35: Call Convert360toDM
        Printer.CurrentX = -152: Printer.CurrentY = -162
        AL = z: Call BoldGTENSXPrinter
        Printer.CurrentX = -146: Printer.CurrentY = -162
        AL = z: Call BoldGUNITSPrinter

        Printer.FontSize = XOPTION!(69): Printer.ForeColor = QBColor(XOPTION!(89))
        z = 30: Call Convert360toDM
        Printer.CurrentX = -202: Printer.CurrentY = -104
        AL = z: Call BoldGTENSXPrinter
        Printer.CurrentX = -196: Printer.CurrentY = -104
        AL = z: Call BoldGUNITSPrinter

        Printer.FontSize = XOPTION!(69): Printer.ForeColor = QBColor(XOPTION!(89))
        z = 25: Call Convert360toDM
        Printer.CurrentX = -228: Printer.CurrentY = -35
        AL = z: Call BoldGTENSXPrinter
        Printer.CurrentX = -222: Printer.CurrentY = -35
        AL = z: Call BoldGUNITSPrinter

        Printer.FontSize = XOPTION!(69): Printer.ForeColor = QBColor(XOPTION!(89))
        z = 20: Call Convert360toDM
        Printer.CurrentX = -228: Printer.CurrentY = 43
        AL = z: Call BoldGTENSXPrinter
        Printer.CurrentX = -222: Printer.CurrentY = 43
        AL = z: Call BoldGUNITSPrinter

        Printer.FontSize = XOPTION!(69): Printer.ForeColor = QBColor(XOPTION!(89))
        z = 15: Call Convert360toDM
        Printer.CurrentX = -202: Printer.CurrentY = 112
        AL = z: Call BoldGTENSXPrinter
        Printer.CurrentX = -196: Printer.CurrentY = 112
        AL = z: Call BoldGUNITSPrinter

        Printer.FontSize = XOPTION!(69): Printer.ForeColor = QBColor(XOPTION!(89))
        z = 10: Call Convert360toDM
        Printer.CurrentX = -150: Printer.CurrentY = 172
        AL = z: Call BoldGTENSXPrinter
        Printer.CurrentX = -144: Printer.CurrentY = 172
        AL = z: Call BoldGUNITSPrinter

        Printer.FontSize = XOPTION!(69): Printer.ForeColor = QBColor(XOPTION!(89))
        z = 5: Call Convert360toDM
        Printer.CurrentX = -83: Printer.CurrentY = 208
        AL = z: Call BoldGTENSXPrinter
        Printer.CurrentX = -77: Printer.CurrentY = 208
        AL = z: Call BoldGUNITSPrinter
Else
    For t = 1 To 12
        Printer.FontSize = XOPTION!(79): Printer.ForeColor = QBColor(XOPTION!(104))
        z = HC1(t): Call Convert360toDM
        Printer.CurrentX = HCUSPDATA%(t * 10 - 10): Printer.CurrentY = HCUSPDATA%(t * 10 - 9)
        AL = z1: Call BoldGTENSXPrinter
        Printer.CurrentX = HCUSPDATA%(t * 10 - 8): Printer.CurrentY = HCUSPDATA%(t * 10 - 7)
        AL = z1: Call BoldGUNITSPrinter
        Printer.CurrentX = HCUSPDATA%(t * 10 - 6): Printer.CurrentY = HCUSPDATA%(t * 10 - 5)
        Printer.FontSize = XOPTION!(80): Printer.ForeColor = QBColor(XOPTION!(105))
        Call GSIGNSPrinter: Printer.FontSize = XOPTION!(81)
        Printer.ForeColor = QBColor(XOPTION!(106))
        Printer.CurrentX = HCUSPDATA%(t * 10 - 4): Printer.CurrentY = HCUSPDATA%(t * 10 - 3)
        AL = z2: Call GTENSXPrinter
        Printer.CurrentX = HCUSPDATA%(t * 10 - 2): Printer.CurrentY = HCUSPDATA%(t * 10 - 1)
        AL = z2: Call GUNITSPrinter
    Next t
End If
End Sub

Private Sub PutPlanetsInChartwheel()
    Dim constant_height, temp1, Hse1%

    Hse1% = 4
    If XOPTION!(28) = 1 Then Hse1% = 3

    z = SORT(X): Call Convert360toDM
    wheels_90.FontSize = XOPTION!(124)          'font size for planets

    If HOUSEY <> 12 Then
        temp1 = TheRadiusX%(HOUSEY + 1) - TheRadiusX%(HOUSEY)
    Else
        temp1 = TheRadiusX%(1) - TheRadiusX%(12)
    End If

    If InnerOuter_90% <> 1 Then
        Radius = Radius + (INDEXY * temp1 / MaxInHouse%)
    End If

    If SORTPOS(X) > 48 Then
        constant_height = TextHeight(Chr$(247))

        If Angle >= 337.5 Or Angle < 22.5 Then
            Radius = Radius + XOPTION!(125) - 1 + Sine(Angle) * constant_height * 1
        ElseIf Angle >= 22.5 And Angle < 67.5 Then
            Radius = Radius + XOPTION!(125) + Sine(Angle) * constant_height * 1.33
        ElseIf Angle >= 67.5 And Angle < 112.5 Then
            Radius = Radius + XOPTION!(125) - 0 + Sine(Angle) * constant_height * 1.33
        ElseIf Angle >= 112.5 And Angle < 157.5 Then
            Radius = Radius + XOPTION!(125) - 14 - Sine(Angle) * constant_height * 1#
        ElseIf Angle >= 157.5 And Angle < 202.5 Then
            Radius = Radius + XOPTION!(125) - 12 + Sine(Angle) * constant_height * 1
        ElseIf Angle >= 202.5 And Angle < 247.5 Then
            Radius = Radius + XOPTION!(125) - 10 + Sine(Angle) * constant_height * 1.33
        ElseIf Angle >= 247.5 And Angle < 270 Then
            Radius = Radius + XOPTION!(125) - 10 + Sine(Angle) * constant_height * 1.33
        ElseIf Angle >= 270 And Angle < 292.5 Then
            Radius = Radius + XOPTION!(125) + 5 - Sine(Angle) * constant_height * 1#
        ElseIf Angle >= 292.5 And Angle < 337.5 Then
            Radius = Radius + XOPTION!(125) + 7 - Sine(Angle) * constant_height * 1.33
        End If

        ROW = (Radius * Sine(Angle))
        COL = Radius * Cosine(Angle)

        wheels_90.ForeColor = QBColor(XOPTION!(92))

        CurrentY = ROW: CurrentX = COL

        Call GPLANETS

        Exit Sub
    End If

    ROW = (Radius * Sine(Angle)): COL = Radius * Cosine(Angle)

    wheels_90.ForeColor = QBColor(XOPTION!(92))
    CurrentY = ROW: CurrentX = COL: Call GPLANETS

    If XOPTION!(50) = 2 Then Exit Sub

    If (HOUSEY >= Hse1% And HOUSEY <= Hse1% + 5) Then
       If NatORSyn_90% <> 2 Then
            wheels_90.ForeColor = QBColor(XOPTION!(95))
            NumeralCharacterWidth% = wheels_90.TextWidth(Chr$(48)) + XOPTION!(61)
            NumeralCharacterHeight% = Abs(wheels_90.TextHeight(Chr$(48))) + XOPTION!(63)
            Call AdjustNCH1 'adjust NumeralCharacterHeight% for screen
            Call ChangeRadiusForNumeral
            wheels_90.FontSize = XOPTION!(75)
            NumeralCharacterWidth% = wheels_90.TextWidth(Chr$(48)) + XOPTION!(61)
            NumeralCharacterHeight% = Abs(wheels_90.TextHeight(Chr$(48))) + XOPTION!(63)
            Call AdjustNCH1 'adjust NumeralCharacterHeight% for screen
            AL = z2: Call GUNITS: Call ChangeRadiusForNumeral
            AL = z2: Call GTENSX: Call ChangeRadiusForNumeral
       End If

       NumeralCharacterWidth% = wheels_90.TextWidth(Chr$(48)) + XOPTION!(61)
       NumeralCharacterHeight% = Abs(wheels_90.TextHeight(Chr$(48))) + XOPTION!(63)
       Call ChangeRadiusForNumeral: wheels_90.FontSize = XOPTION!(74)
       NumeralCharacterWidth% = wheels_90.TextWidth(Chr$(48)) + XOPTION!(60)
       NumeralCharacterHeight% = Abs(wheels_90.TextHeight(Chr$(48))) + XOPTION!(62)
       wheels_90.ForeColor = QBColor(XOPTION!(94))
       Call GSIGNS: wheels_90.FontSize = XOPTION!(73)
       wheels_90.ForeColor = QBColor(XOPTION!(93))
       NumeralCharacterWidth% = wheels_90.TextWidth(Chr$(48)) + XOPTION!(61)
       NumeralCharacterHeight% = Abs(wheels_90.TextHeight(Chr$(48))) + XOPTION!(63)
       Call ChangeRadiusForNumeral: AL = z1: Call BoldGUNITS
       Call ChangeRadiusForNumeral: AL = z1: Call BoldGTENSX
       Call ChangeRadiusForNumeral
    Else
       Call ChangeRadiusForGlyph: wheels_90.FontSize = XOPTION!(73)
       NumeralCharacterWidth% = wheels_90.TextWidth(Chr$(48)) + XOPTION!(61)
       NumeralCharacterHeight% = Abs(wheels_90.TextHeight(Chr$(48))) + XOPTION!(63)
       wheels_90.ForeColor = QBColor(XOPTION!(93))
       AL = z1: Call BoldGTENSX: Call ChangeRadiusForNumeral
       AL = z1: Call BoldGUNITS: Call ChangeRadiusForNumeral
       wheels_90.FontSize = XOPTION!(74)
       wheels_90.ForeColor = QBColor(XOPTION!(94)): Call GSIGNS
       NumeralCharacterWidth% = wheels_90.TextWidth(Chr$(191 + Q)) + XOPTION!(60)
       NumeralCharacterHeight% = Abs(wheels_90.TextHeight(Chr$(191 + Q))) + XOPTION!(62)
       Call ChangeRadiusForNumeral
       If NatORSyn_90% <> 2 Then
            wheels_90.FontSize = XOPTION!(75)
            wheels_90.ForeColor = QBColor(XOPTION!(95))
            NumeralCharacterWidth% = wheels_90.TextWidth(Chr$(48)) + XOPTION!(61)
            NumeralCharacterHeight% = Abs(wheels_90.TextHeight(Chr$(48))) + XOPTION!(63)
            AL = z2: Call GTENSX: Call ChangeRadiusForNumeral
            AL = z2: Call GUNITS: Call ChangeRadiusForNumeral
       End If
    End If
    If SORTPOS(X) < 11 Or SORTPOS(X) = 13 Then
        If Mid$(Retrograde_90$, SORTPOS(X), 1) = "R" Then
            wheels_90.FontSize = XOPTION!(76)
            temp1 = wheels_90.ForeColor
            wheels_90.ForeColor = QBColor(XOPTION!(96))
            wheels_90.Print Chr$(156):                  'Retrograde
            wheels_90.ForeColor = temp1
        End If
    End If
End Sub

Private Sub PutPlanetsInChartwheelPrinter()
    Dim temp, temp1, Hse1%

    Hse1% = 4: If XOPTION!(28) = 1 Then Hse1% = 3
    z = SORT(X): Call Convert360toDM

    If XOPTION!(199) = 0 Or NatORSyn_90% <> 2 Then
        Printer.FontSize = XOPTION!(82): 'font size for planets
    Else
        Printer.FontSize = XOPTION!(200)
    End If

    If HOUSEY <> 12 Then
        temp1 = TheRadiusX%(HOUSEY + 1) - TheRadiusX%(HOUSEY)
    Else
        temp1 = TheRadiusX%(1) - TheRadiusX%(12)
    End If
    If InnerOuter_90% <> 1 Then Radius = Radius + (INDEXY * temp1 / MaxInHouse%)

'adjust radius for outer two wheels, right side of chart, triple chart, degrees and minutes
    If WheelType_90% = 3 And XOPTION!(199) <> 0 And HOUSEY >= Hse1% And HOUSEY <= Hse1% + 5 Then
        If InnerOuter_90% = 1 Then
            'outer wheel radius
            If HOUSEY = 8 And INDEXY <= 3 Then
                Radius = Radius + XOPTION!(205) - 2
            ElseIf HOUSEY = 8 And INDEXY >= 4 Then
                Radius = Radius + XOPTION!(205) - 4
            ElseIf HOUSEY = 7 Then
                Radius = Radius + XOPTION!(205) - 1
            ElseIf HOUSEY = 4 Then
                Radius = Radius + XOPTION!(205) - 1
            ElseIf HOUSEY = 3 And XOPTION!(28) = 1 Then
                Radius = Radius + XOPTION!(205) - 3
            ElseIf HOUSEY = 3 And XOPTION!(28) = 0 Then
                Radius = Radius + XOPTION!(205)
            ElseIf HOUSEY = 9 And XOPTION!(28) = 0 Then
                'do not adjust
            Else
                Radius = Radius + XOPTION!(205)
            End If
        ElseIf InnerOuter_90% = 2 Then
            'middle wheel radius
            If HOUSEY = 8 Then
                Radius = Radius + XOPTION!(206) - 1
            ElseIf HOUSEY = 7 Then
                Radius = Radius + XOPTION!(206) - 3
            ElseIf HOUSEY = 3 And XOPTION!(28) = 0 Then
                Radius = Radius + XOPTION!(206)
            Else
                Radius = Radius + XOPTION!(206)
            End If
        End If
    End If

    If WheelType_90% = 3 And XOPTION!(199) <> 0 And XOPTION!(28) = 0 Then
        'middle wheel radius
        If HOUSEY = 9 And InnerOuter_90% = 2 Then
            Radius = Radius - 2
        ElseIf HOUSEY = 3 And InnerOuter_90% <> 0 Then
            Radius = Radius + XOPTION!(206)
        End If
    End If

    If WheelType_90% = 3 And InnerOuter_90% <> 0 And XOPTION!(199) <> 0 Then
        'middle wheel radius
        If HOUSEY = 2 And INDEXY >= 4 Then
            Radius = Radius + XOPTION!(206)
        End If
    End If

    Radius = Radius * 0.9875

    ROW = (Radius * Sine(Angle)): COL = Radius * Cosine(Angle)
    Printer.ForeColor = QBColor(XOPTION!(107))
    Printer.CurrentY = ROW: Printer.CurrentX = COL: Call GPLANETSPrinter

    If XOPTION!(50) = 2 Then Exit Sub

    If (HOUSEY >= Hse1% And HOUSEY <= Hse1% + 5) Then
       If NatORSyn_90% <> 2 Or XOPTION!(199) <> 0 Then
            Printer.ForeColor = QBColor(XOPTION!(110))
            NumeralCharacterWidth% = Printer.TextWidth(Chr$(48)) + XOPTION!(65)
            NumeralCharacterHeight% = Abs(Printer.TextHeight(Chr$(48))) + XOPTION!(67)
            Call AdjustNCHP1 'adjust NumeralCharacterHeight% for printer
            Call ChangeRadiusForNumeral
            If XOPTION!(199) = 0 Or NatORSyn_90% <> 2 Then
                Printer.FontSize = XOPTION!(85)
            Else
                Printer.FontSize = XOPTION!(203)
            End If
            NumeralCharacterWidth% = Printer.TextWidth(Chr$(48)) + XOPTION!(65)
            NumeralCharacterHeight% = Abs(Printer.TextHeight(Chr$(48))) + XOPTION!(67)
            Call AdjustNCHP1 'adjust NumeralCharacterHeight% for printer
            AL = z2: Call GUNITSPrinter: Call ChangeRadiusForNumeral
            AL = z2: Call GTENSXPrinter: Call ChangeRadiusForNumeral
       End If
       NumeralCharacterWidth% = Printer.TextWidth(Chr$(48)) + XOPTION!(65)
       NumeralCharacterHeight% = Abs(Printer.TextHeight(Chr$(48))) + XOPTION!(67)
       Call ChangeRadiusForNumeral
       If XOPTION!(199) = 0 Or NatORSyn_90% <> 2 Then
           Printer.FontSize = XOPTION!(84)
       Else
           Printer.FontSize = XOPTION!(202)
       End If
       NumeralCharacterWidth% = Printer.TextWidth(Chr$(48)) + XOPTION!(64)
       NumeralCharacterHeight% = Abs(Printer.TextHeight(Chr$(48))) + XOPTION!(66)
       Printer.ForeColor = QBColor(XOPTION!(109))
       Call GSIGNSPrinter
       If XOPTION!(199) = 0 Or NatORSyn_90% <> 2 Then
           Printer.FontSize = XOPTION!(83)
       Else
           Printer.FontSize = XOPTION!(201)
       End If
       Printer.ForeColor = QBColor(XOPTION!(108))
       NumeralCharacterWidth% = Printer.TextWidth(Chr$(48)) + XOPTION!(65)
       NumeralCharacterHeight% = Abs(Printer.TextHeight(Chr$(48))) + XOPTION!(67)
       Call ChangeRadiusForNumeral: AL = z1: Call BoldGUNITSPrinter
       Call ChangeRadiusForNumeral: AL = z1: Call BoldGTENSXPrinter
       Call ChangeRadiusForNumeral
    Else
       Call ChangeRadiusForGlyph
       If XOPTION!(199) = 0 Or NatORSyn_90% <> 2 Then
           Printer.FontSize = XOPTION!(83)
       Else
           Printer.FontSize = XOPTION!(201)
       End If
       NumeralCharacterWidth% = Printer.TextWidth(Chr$(48)) + XOPTION!(65)
       NumeralCharacterHeight% = Abs(Printer.TextHeight(Chr$(48))) + XOPTION!(67)
       Printer.ForeColor = QBColor(XOPTION!(108))
       AL = z1: Call BoldGTENSXPrinter: Call ChangeRadiusForNumeral
       AL = z1: Call BoldGUNITSPrinter: Call ChangeRadiusForNumeral
       If XOPTION!(199) = 0 Or NatORSyn_90% <> 2 Then
           Printer.FontSize = XOPTION!(84)
       Else
           Printer.FontSize = XOPTION!(202)
       End If
       Printer.ForeColor = QBColor(XOPTION!(109)): Call GSIGNSPrinter
       NumeralCharacterWidth% = Printer.TextWidth(Chr$(191 + Q)) + XOPTION!(64)
       NumeralCharacterHeight% = Abs(Printer.TextHeight(Chr$(191 + Q))) + XOPTION!(66)
       Call ChangeRadiusForNumeral
       If NatORSyn_90% <> 2 Or XOPTION!(199) <> 0 Then
            If XOPTION!(199) = 0 Or NatORSyn_90% <> 2 Then
                Printer.FontSize = XOPTION!(85)
            Else
                Printer.FontSize = XOPTION!(203)
            End If
            Printer.ForeColor = QBColor(XOPTION!(110))
            NumeralCharacterWidth% = Printer.TextWidth(Chr$(48)) + XOPTION!(65)
            NumeralCharacterHeight% = Abs(Printer.TextHeight(Chr$(48))) + XOPTION!(67)
            AL = z2: Call GTENSXPrinter: Call ChangeRadiusForNumeral
            AL = z2: Call GUNITSPrinter: Call ChangeRadiusForNumeral
       End If
    End If
    If SORTPOS(X) < 11 Then
        If Mid$(Retrograde_90$, SORTPOS(X), 1) = "R" Then
            If XOPTION!(199) = 0 Or NatORSyn_90% <> 2 Then
                Printer.FontSize = XOPTION!(86)
            Else
                Printer.FontSize = XOPTION!(204)
            End If
            temp1 = Printer.ForeColor
            Printer.ForeColor = QBColor(XOPTION!(111))
            iBKMode = SetBkMode(Printer.hDC, TRANSPARENT)
            Printer.Print Chr$(156):                    'Retrograde
            Printer.ForeColor = temp1
        End If
    End If
End Sub

Private Sub SetupAndDisplayPlanets()
        Dim X7%, dist, dist1, LastAngle, t9, NextCusp
        Dim overflow_cntr%

        If NatORSyn_90% = 0 Or InnerOuter_90% = 1 Then
           MaxInHouse% = 9			'was 10 before 25 May 2005, but that gave overlapping planets in some cases.
           DegreeIncrement = 3#
           For X7% = 1 To 12: TheAngleX%(X7%) = OCAngleX%(X7%): Next X7%
           For X7% = 1 To 12: TheRadiusX%(X7%) = OCRadiusX%(X7%): Next X7%
           Retrograde_90$ = CWRetrograde$
        End If

        If NatORSyn_90% = 1 And InnerOuter_90% = 0 Then
           MaxInHouse% = 5: DegreeIncrement = 5.3
           For X7% = 1 To 12: TheAngleX%(X7%) = ICDAngleX%(X7%): Next X7%
           For X7% = 1 To 12: TheRadiusX%(X7%) = ICDRadiusX%(X7%): Next X7%
        End If

        LastAngle = -100
'sort the planets in Planets() into the proper order
        Call SortPlanets
'count the number of planets in each house
        Call CountPlanets

        overflow_cntr% = 0

    For X = num_pl_bodies_90% To 1 Step -1: 'was 10

        temp = HOUSEY
        HOUSEY = Val(Mid$(ph$, SORTPOS(X) * 10 - 9, 2))
        If temp = HOUSEY Then
'this deals with the next planet in the same house
           If NOPIH(HOUSEY) > MaxInHouse% And (SORTPOS(X) = 12 Or SORTPOS(X) = 13) Then GoTo SHT9: 'was Exit Sub
           If HOUSEY < 10 Then
              FromCusp = CRUNCH(SORT(X) - HC1(HOUSEY + 3)): FromCusp = CRUNCH(FromCusp)
              If FromCusp >= 360 - 1 / 36000 And FromCusp <= 360 + 1 / 36000 Then FromCusp = 0
              INDEXY = Fix(FromCusp * MaxInHouse% / DegEachHouse(HOUSEY + 3))
           End If
           If HOUSEY > 9 Then
              FromCusp = CRUNCH(SORT(X) - HC1(HOUSEY - 9)): FromCusp = CRUNCH(FromCusp)
              If FromCusp >= 360 - 1 / 36000 And FromCusp <= 360 + 1 / 36000 Then FromCusp = 0
              INDEXY = Fix(FromCusp * MaxInHouse% / DegEachHouse(HOUSEY - 9))
           End If
           If INDEXY >= MaxInHouse% - NOPIH(HOUSEY) Then
              If MaxInHouse% - INDEXY - NOPIH(HOUSEY) + PlanetsDone% <= 0 Then
                 IDX = INDEXY - (NOPIH(HOUSEY) - PlanetsDone%)
                 If IDX < 0 Then GoTo p4a
                 If SpotFilled%(MaxInHouse% * (HOUSEY - 1) + INDEXY) = 0 Then
                    INDEXY = MaxInHouse% - (NOPIH(HOUSEY) - PlanetsDone%) - 1
                 Else
p4a:                INDEXY = MaxInHouse% - NOPIH(HOUSEY)
                 End If
              End If
              If INDEXY < 0 Then INDEXY = 0
           End If
           GoTo SHT5
        End If

'this starts a new house placement set
        PlanetsDone% = 1
        If HOUSEY < 10 Then
           FromCusp = CRUNCH(SORT(X) - HC1(HOUSEY + 3)): FromCusp = CRUNCH(FromCusp)
           If FromCusp >= 360 - 1 / 36000 And FromCusp <= 360 + 1 / 36000 Then FromCusp = 0
           INDEXY = Fix(FromCusp * MaxInHouse% / DegEachHouse(HOUSEY + 3))
        End If
        If HOUSEY > 9 Then
           FromCusp = CRUNCH(SORT(X) - HC1(HOUSEY - 9)): FromCusp = CRUNCH(FromCusp)
           If FromCusp >= 360 - 1 / 36000 And FromCusp <= 360 + 1 / 36000 Then FromCusp = 0
           INDEXY = Fix(FromCusp * MaxInHouse% / DegEachHouse(HOUSEY - 9))
        End If
        If INDEXY >= MaxInHouse% - NOPIH(HOUSEY) Then
              If MaxInHouse% - INDEXY - NOPIH(HOUSEY) + PlanetsDone% <= 0 Then
                 IDX = INDEXY - (NOPIH(HOUSEY) - PlanetsDone%)
                 If IDX < 0 Then GoTo P4B
                 If SpotFilled%(MaxInHouse% * (HOUSEY - 1) + INDEXY) = 0 Then
                    INDEXY = MaxInHouse% - (NOPIH(HOUSEY) - PlanetsDone%) - 1
                 Else
P4B:                INDEXY = MaxInHouse% - NOPIH(HOUSEY)
                 End If
              End If
              If INDEXY < 0 Then INDEXY = 0
        End If
        If NOPIH(HOUSEY) <> 0 Then
           If NOPIH(HOUSEY) > MaxInHouse% And (SORTPOS(X) = 12 Or SORTPOS(X) = 13) Then GoTo SHT9: 'was Exit Sub
        End If
SHT5:   If SpotFilled%(MaxInHouse% * (HOUSEY - 1) + INDEXY) = 1 Then
           INDEXY = INDEXY + 1: GoTo SHT5
        End If
        CWIndexy(SORTPOS(X)) = INDEXY
        SpotFilled%(MaxInHouse% * (HOUSEY - 1) + INDEXY) = 1
        Angle = TheAngleX%(HOUSEY) + INDEXY * DegreeIncrement

        If Angle >= 360 Then
            Angle = Angle - 360
            'overflow_cntr% = overflow_cntr% + 1
            'GoTo SHT9
        End If

        Radius = TheRadiusX%(HOUSEY)
        If InnerOuter_90% = 1 Then
            Radius = XRADIUSX%(CInt(Angle))
        End If

        CWPlanetAngle_90(SORTPOS(X)) = Angle
        If InnerOuter_90% = 0 Then
            'inner chartwheel
            If Angle >= 45 And Angle <= 135 Then
                CWPlanetAngle_90(SORTPOS(X)) = CWPlanetAngle_90(SORTPOS(X)) - 1
            ElseIf Angle >= 185 And Angle <= 215 Then
                CWPlanetAngle_90(SORTPOS(X)) = CWPlanetAngle_90(SORTPOS(X)) + 3
            ElseIf Angle > 215 And Angle <= 270 Then
                CWPlanetAngle_90(SORTPOS(X)) = CWPlanetAngle_90(SORTPOS(X)) + 3
            ElseIf Angle >= 330 And Angle <= 360 Then
                CWPlanetAngle_90(SORTPOS(X)) = CWPlanetAngle_90(SORTPOS(X)) - 2
            End If
        Else
            'outer chartwheel
            If Angle >= 45 And Angle <= 95 Then
                CWPlanetAngle_90(SORTPOS(X)) = CWPlanetAngle_90(SORTPOS(X)) - 1
            ElseIf Angle > 95 And Angle <= 130 Then
                CWPlanetAngle_90(SORTPOS(X)) = CWPlanetAngle_90(SORTPOS(X)) - 2
            ElseIf Angle > 130 And Angle <= 150 Then
                CWPlanetAngle_90(SORTPOS(X)) = CWPlanetAngle_90(SORTPOS(X)) - 1
            ElseIf Angle >= 180 And Angle <= 210 Then
                CWPlanetAngle_90(SORTPOS(X)) = CWPlanetAngle_90(SORTPOS(X)) + 2
            ElseIf Angle > 210 And Angle <= 240 Then
                CWPlanetAngle_90(SORTPOS(X)) = CWPlanetAngle_90(SORTPOS(X)) + 3
            ElseIf Angle > 240 And Angle <= 270 Then
                CWPlanetAngle_90(SORTPOS(X)) = CWPlanetAngle_90(SORTPOS(X)) + 2
            ElseIf Angle > 270 And Angle <= 280 Then
                CWPlanetAngle_90(SORTPOS(X)) = CWPlanetAngle_90(SORTPOS(X)) + 1
            ElseIf Angle >= 330 And Angle <= 360 Then
                CWPlanetAngle_90(SORTPOS(X)) = CWPlanetAngle_90(SORTPOS(X)) - 2
            End If
        End If

        PlanetsDone% = PlanetsDone% + 1
        If PrntObj_90% = 0 Then
            Call PutPlanetsInChartwheel
        Else
            Call PutPlanetsInChartwheelPrinter
        End If
SHT9:
    Next X

    wheels_90.Caption = XCaption$ & "Planets not displayed = " & overflow_cntr%
End Sub

Private Sub SortPlanets()
        Dim X, Y

'set zero planets in the houses
        For X = 1 To 12: NOPIH(X) = 0: Next X

        For X = 1 To num_pl_bodies_90%: 'was 10
        If NatORSyn_90% = 1 And InnerOuter_90% = 0 Then
           SORT(X) = p1(X): SORTPOS(X) = X
        End If
        If NatORSyn_90% = 0 Or InnerOuter_90% = 1 Then
           SORT(X) = CWPlanets_90(X): SORTPOS(X) = X
        End If
        Next X

        If InnerOuter_90% = 1 Then
            ph$ = OuterPH_90$
        End If

        If NatORSyn_90% = 1 And InnerOuter_90% = 0 Then
            For X = 1 To num_pl_bodies_90%: 'was 10
                p2(X) = CWPlanets_90(X)
                Planets(X) = p1(X)
            Next X

            For X = 1 To 12
                HC(X) = CWHC_90(X)
            Next X

            Call Planets_in_houses_90

            Retrograde_90$ = h1_90$

            For X = 1 To num_pl_bodies_90%: 'was 10
                CWPlanets_90(X) = p2(X)
            Next X
        End If

        For X = 1 To num_pl_bodies_90% - 1: 'was 9
            For Y = X + 1 To num_pl_bodies_90%: 'was 10
                If SORT(Y) > SORT(X) Then
                    temp = SORT(X): temp1 = SORTPOS(X)
                    SORT(X) = SORT(Y): SORTPOS(X) = SORTPOS(Y)
                    SORT(Y) = temp: SORTPOS(Y) = temp1
                End If
            Next Y
        Next X
End Sub

Private Sub mnuUseList1_Click()
    FileCopy App.path & "\planet_list1.txt", App.path & "\options_90.opt"

    Call GetOptions_90
    Call Get_Planet_Positions_90

    If WheelType_90% = 1 Then
        Call Draw_single_90_natal_wheel
    Else
        Call Draw_dual_90_natal_transit_wheel
    End If
End Sub


Private Sub mnuUseList2_Click()
    FileCopy App.path & "\planet_list2.txt", App.path & "\options_90.opt"

    Call GetOptions_90
    Call Get_Planet_Positions_90

    If WheelType_90% = 1 Then
        Call Draw_single_90_natal_wheel
    Else
        Call Draw_dual_90_natal_transit_wheel
    End If
End Sub


Private Sub mnuUseList3_Click()
    FileCopy App.path & "\planet_list3.txt", App.path & "\options_90.opt"

    Call GetOptions_90
    Call Get_Planet_Positions_90

    If WheelType_90% = 1 Then
        Call Draw_single_90_natal_wheel
    Else
        Call Draw_dual_90_natal_transit_wheel
    End If
End Sub


